import torch
import torch.nn as nn


class DataNormalizer(nn.Module):

    def __init__(self, mean: torch.Tensor, std: torch.Tensor):
        super(DataNormalizer, self).__init__()
        self.register_buffer('mean', mean)
        self.register_buffer('std', std)

    def set_mean_std_from_data(self, data):
        self.mean = torch.mean(data, dim=0, keepdim=True)
        self.std = torch.std(data, dim=0, keepdim=True)

    def normalize(self, data):
        data = (data - self.mean) / self.std

        return data

    def normalize_cuda(self, data):
        data = (data - self.mean) / self.std

        return data