import torch

def varsig_from_logits(logits: torch.Tensor):
    assert len(logits.shape) == 3
    assert logits.shape[2] == 2
    # calculate the simple l0-l1
    sigs = logits[:, :, 0] - logits[:, :, 1]
    return varsig_from_sigs(sigs)


def varsig_from_sigs(sigs: torch.Tensor):
    assert len(sigs.shape) == 2
    return torch.var(sigs, dim=-1, keepdim=True)


def stdsig_from_logits(logits: torch.Tensor):
    assert len(logits.shape) == 3
    assert logits.shape[2] == 2
    # calculate the simple l0-l1
    sigs = logits[:, :, 0] - logits[:, :, 1]
    return stdsig_from_sigs(sigs)


def stdsig_from_sigs(sigs: torch.Tensor):
    assert len(sigs.shape) == 2
    return torch.std(sigs, dim=-1, keepdim=True)
